Require Import ssreflect ssrbool ssrfun eqtype ssrnat seq choice fintype.
Require Import div path bigop prime finset fingroup morphism quotient.

Set Implicit Arguments.
Unset Strict Implicit.
Unset Printing Implicit Defensive.

Section Ex10.

Variable gT : finGroupType.
Implicit Types G H K : {group gT}.
Open Scope group_scope.

Lemma ex10_1 x G H : x \in H  -> H \subset G -> x \in G.


Lemma ex10_2 x y G H : x \in H :* y  -> H \subset G -> x \in G :* y.


Lemma ex10_3 G H : H <| G -> H * G = G * H.


(* Prove this without using the lemma ltn_quotient, and remember that
   quotient is a morphism *)
Lemma ex10_ltn_quotient A H :
  1 < #|H| -> H <| A -> 0 < #|A| - #|A / H|.
Proof.


Qed.

(* Give a look at: Search _ "imset" "P". and at the notation of 
   set comprehension. Also look at "bigcup" and subsetP *)
Lemma ex10_4 G H : H \subset 'N(G) -> [set g ^ h | g in G , h in H] = G.
Proof.





Qed.

(* Prove the following lemma. Give a look at setX, leq_imset_card,
   subset_leq_card and imsetP *)
Lemma ex10_ineq G H K : #|G : H :&: K| <= #|G : H| * #|G : K|.
Proof.










Qed.

(* Advanced: read in the documentation (page 46) what happens
   when one writes 'rewrite (lem1, lem2, lem3)' and use it to solve
   the following identity. *)
Lemma Hall_Witt_identity (x y z : gT) :
   [~ x, y^-1, z] ^ y * [~ y, z^-1, x] ^ z * [~ z, x^-1, y] ^ x = 1.
Proof.


Qed.

End Ex10.
